/**************************************************************************
***
***    Copyright (c) 1995-1997 by ABKGroup, UCLA VLSI CAD Laboratory,
***    UCLA Computer Science Department, Los Angeles, CA 90095-1596 USA,
***    and by the Regents of the University of California.
***    All rights reserved.
***
***    No portion of this file may be used, copied, or transmitted for
***    any purpose, including any research or commercial purpose,
***    without the express written consent of Professor Andrew B. Kahng,
***    UCLA Computer Science Department, 3713 Boelter Hall, Los Angeles,
***    CA 90095-1596 USA.   Any copy made of this file must include this
***    notice.    ABKGroup and the Regents of the University of California
***    retain title to all copies of this file and/or its compiled
***    derivatives.
***
***************************************************************************/

// Created: Dev 22, 1998 by Andrew Caldwell

#include "constrForCapo.h" 

ConstraintsForCapo::ConstraintsForCapo(
	const HGraphFixed& hgraph, const Placement& pl)
{
   abkfatal(pl.getSize() == hgraph.getNumNodes(), 
	"hgraph,placement size mis-match in ConstraintsForCapo");

   unsigned numFixed=hgraph.getNumTerminals();
   Placement fixedLocs(numFixed);
   Mapping   mp(numFixed,pl.getSize());

   for(unsigned t=0; t != numFixed; t++)
   {  mp[t]=t; fixedLocs[t]=pl[t]; }

   SubPlacement subPl(pl,mp);
   FixedGroupConstraint      fgc(subPl,fixedLocs);
   /* _ctrs. */ add(fgc);
   /* _ctrs. */ compactify();
}

